import wx

class MailOptionsDialog(wx.Dialog):
    def __init__(self, parent, reply, cclist, domain, *args, **kwds):
        kwds["title"] = "Mail Options"
        
        wx.Dialog.__init__(self, parent, *args, **kwds)

        self.replyLabel = wx.StaticText(self, -1, "Reply-to Address")
        self.reply = wx.TextCtrl(self, -1, reply, size=(200, 30))
        self.ccLabel = wx.StaticText(self, -1, "CC list")
        self.cc = wx.TextCtrl(self, -1, cclist, size=(200, 30))
        self.domainLabel = wx.StaticText(self, -1, "Student Domain")
        self.domain = wx.TextCtrl(self, -1, domain)

        self.okButton = wx.Button(self, -1, "OK")
        self.cancelButton = wx.Button(self, -1, "Cancel")

        self.sizer = wx.FlexGridSizer(4, 2, 5, 5)
        self.sizer.Add(self.replyLabel, 0, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.reply, 1, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.ccLabel, 0, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.cc, 1, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.domainLabel, 0, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.domain, 1, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.okButton, 0, wx.CENTER, 3)
        self.sizer.Add(self.cancelButton, 0, wx.CENTER, 3)

        self.SetSizer(self.sizer)
        self.sizer.SetSizeHints(self)

        wx.EVT_BUTTON(self.okButton, -1, self.onOK)
        wx.EVT_BUTTON(self.cancelButton, -1, self.onCancel)

        wx.EVT_SIZE(self, self.onSize)

    def onSize(self, event):
        self.sizer.SetSizeHints(self)        
        self.Layout()

    def onOK(self, event):
        self.EndModal(wx.ID_OK)

    def onCancel(self, event):
        self.EndModal(wx.ID_CANCEL)

    
