import wx

class MergeDialog(wx.Dialog):
    def __init__(self, parent, *args, **kwds):
        kwds["title"] = "Merge Options"
        
        wx.Dialog.__init__(self, parent, *args, **kwds)

        choices = ["Old only", "Merge, prefer old", \
                   "Merge, prefer new", "New only"]
        self.rubric = wx.RadioBox(self, label="Rubric",
                                  choices=choices)
        self.comments = wx.RadioBox(self, label="User Comments",
                                    choices=choices)

        self.okButton = wx.Button(self, -1, "OK")
        self.cancelButton = wx.Button(self, -1, "Cancel")
        self.hsizer = wx.BoxSizer(wx.HORIZONTAL)
        self.hsizer.Add(self.okButton, 1, wx.CENTER, 3)
        self.hsizer.Add(self.cancelButton, 1, wx.CENTER, 3)

        self.sizer = wx.FlexGridSizer(3, 1, 5, 5)
        self.sizer.Add(self.rubric, 1, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.comments, 1, wx.EXPAND|wx.ALL, 3)
        self.sizer.Add(self.hsizer)

        self.SetSizer(self.sizer)
        self.sizer.SetSizeHints(self)

        wx.EVT_BUTTON(self.okButton, -1, self.onOK)
        wx.EVT_BUTTON(self.cancelButton, -1, self.onCancel)

        wx.EVT_SIZE(self, self.onSize)

    def onSize(self, event):
        self.sizer.SetSizeHints(self)        
        self.Layout()

    def onOK(self, event):
        self.EndModal(wx.ID_OK)

    def onCancel(self, event):
        self.EndModal(wx.ID_CANCEL)

    def GetVals(self):
        return self.rubric.GetSelection(),\
               self.comments.GetSelection()

    
