#!/usr/bin/python

import sys
import commands
import getopt
import os

def usage():
    print "Usage: exitcode.py FILE points"
    print "If FILE executes and returns exit code 0, grant points."
    print
    print "--invert\t\tSucceed on non-zero exit code."
    sys.exit(2)
    
def defaults():
    print "Exit Code"
    print "all"
    print "*graderExe"
    usage()
	
try:
    opts, args = getopt.getopt(sys.argv[1:], "", ["help", "defaults",
                                                  "invert"])
    
except getopt.GetoptError:
    # print help information and exit:
    usage()
    sys.exit(0)


invert = False
for o, a in opts:
	if o == "--help":
            usage()
        if o == "--defaults":
            defaults()
        if o == "--invert":
            invert = True

try:
    points = float(args.pop())
except:
    print "Bad point value"
    sys.exit(1)

os.chdir(os.path.dirname(args[-1]))
args[-1] = "./" + os.path.basename(args[-1])

if not os.access(args[-1], os.X_OK):
    print "Can't run executable", args[-1]
    sys.exit(1)

status, output = commands.getstatusoutput(args[-1])

if status == 0 and not invert:
    print points
    print "Program exited with exit code 0"
elif status == 0 and invert:
    print 0
    print "Program exited with exit code 0"
elif status and not invert:
    print 0
    print "Program exited with non-zero exit code"
else:
    print points
    print "Program exited with non-zero exit code"    
    
sys.exit(0)
