#!/usr/bin/python

import sys
import getopt
import os

def usage():
    print "Usage: filename.py [OPTION] FILE.1 .. FILE.N points"
    print "If at least one file is named correctly, pass."
    print
    print "--correct-name=name\tThe filename that we are testing."
    sys.exit(2)

def defaults():
    print "Correct Filename"
    print "all"
    print "*"
    usage()


try:
    opts, args = getopt.getopt(sys.argv[1:], "", ["help", "defaults",
                                                  "correct-name="])

    
except getopt.GetoptError:
    # print help information and exit:
    usage()
    sys.exit(0)

filename = None

for o, a in opts:
    if o == "--help":
        usage()
    if o == "--defaults":
        defaults()

    try:        
        if o == "--correct-name":
            filename = a

    except:
        usage()

if filename == None:
    usage()

try:
    points = float(args.pop())
except:
    sys.exit(1)

for f in args:
    if os.path.basename(f) == os.path.basename(filename):
        print points
        print filename, "found."
        sys.exit(0)

print 0
print filename, "not found."
sys.exit(0)
