import wx

from memTree import *

class TestTree(MemTree):
    def __init__(self, agar, *args, **kwds):
        MemTree.__init__(self, "Tests", *args, **kwds)

        self.a = agar
        self.update()

        wx.EVT_TREE_BEGIN_DRAG(self, -1, self.onDrag)

    def update(self):
        names = [x for x in self.a.tests]
        names.sort()

        for name in names:
            self.pathAdd([name])

        MemTree.update(self)
        
    def onDrag(self, event):
        testName = str(self.GetItemText(self.GetSelection()))

        if testName not in self.a.tests:
            return
        
        data = wx.CustomDataObject(wx.CustomDataFormat("AgarTest"))
        data.SetData(testName)

        ds = wx.DropSource(self)
        ds.SetData(data)
        ds.DoDragDrop(True)

        
